<?php
// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die;
}

if ( ! class_exists( 'BESTBUG_CRYPTO_HELPER' ) ) {
	/**
	 * BESTBUG_CRYPTO_HELPER Class
	 *
	 * @since	1.0
	 */
	class BESTBUG_CRYPTO_HELPER {
		
		public static $currencies_symbol;
		public static $alias;
		public static $image_url;
		
		/**
		 * Constructor
		 *
		 * @return	void
		 * @since	1.0
		 */
		function __construct() {
			self::$alias = array(
				'MIOTA' => 'IOT',
			);
			
			self::$currencies_symbol = json_decode('{"USD":{"symbol":"$","symbol_native":"$"},"CAD":{"symbol":"CA$","symbol_native":"$"},"EUR":{"symbol":"€","symbol_native":"€"},"AED":{"symbol":"AED","symbol_native":"د.إ.‏"},"AFN":{"symbol":"Af","symbol_native":"؋"},"ALL":{"symbol":"ALL","symbol_native":"Lek"},"AMD":{"symbol":"AMD","symbol_native":"դր."},"ARS":{"symbol":"AR$","symbol_native":"$"},"AUD":{"symbol":"AU$","symbol_native":"$"},"AZN":{"symbol":"man.","symbol_native":"ман."},"BAM":{"symbol":"KM","symbol_native":"KM"},"BDT":{"symbol":"Tk","symbol_native":"৳"},"BGN":{"symbol":"BGN","symbol_native":"лв."},"BHD":{"symbol":"BD","symbol_native":"د.ب.‏"},"BIF":{"symbol":"FBu","symbol_native":"FBu"},"BND":{"symbol":"BN$","symbol_native":"$"},"BOB":{"symbol":"Bs","symbol_native":"Bs"},"BRL":{"symbol":"R$","symbol_native":"R$"},"BWP":{"symbol":"BWP","symbol_native":"P"},"BYR":{"symbol":"BYR","symbol_native":"BYR"},"BZD":{"symbol":"BZ$","symbol_native":"$"},"CDF":{"symbol":"CDF","symbol_native":"FrCD"},"CHF":{"symbol":"CHF","symbol_native":"CHF"},"CLP":{"symbol":"CL$","symbol_native":"$"},"CNY":{"symbol":"CN¥","symbol_native":"CN¥"},"COP":{"symbol":"CO$","symbol_native":"$"},"CRC":{"symbol":"₡","symbol_native":"₡"},"CVE":{"symbol":"CV$","symbol_native":"CV$"},"CZK":{"symbol":"Kč","symbol_native":"Kč"},"DJF":{"symbol":"Fdj","symbol_native":"Fdj"},"DKK":{"symbol":"Dkr","symbol_native":"kr"},"DOP":{"symbol":"RD$","symbol_native":"RD$"},"DZD":{"symbol":"DA","symbol_native":"د.ج.‏"},"EEK":{"symbol":"Ekr","symbol_native":"kr"},"EGP":{"symbol":"EGP","symbol_native":"ج.م.‏"},"ERN":{"symbol":"Nfk","symbol_native":"Nfk"},"ETB":{"symbol":"Br","symbol_native":"Br"},"GBP":{"symbol":"£","symbol_native":"£"},"GEL":{"symbol":"GEL","symbol_native":"GEL"},"GHS":{"symbol":"GH₵","symbol_native":"GH₵"},"GNF":{"symbol":"FG","symbol_native":"FG"},"GTQ":{"symbol":"GTQ","symbol_native":"Q"},"HKD":{"symbol":"HK$","symbol_native":"$"},"HNL":{"symbol":"HNL","symbol_native":"L"},"HRK":{"symbol":"kn","symbol_native":"kn"},"HUF":{"symbol":"Ft","symbol_native":"Ft"},"IDR":{"symbol":"Rp","symbol_native":"Rp"},"ILS":{"symbol":"₪","symbol_native":"₪"},"INR":{"symbol":"Rs","symbol_native":"টকা"},"IQD":{"symbol":"IQD","symbol_native":"د.ع.‏"},"IRR":{"symbol":"IRR","symbol_native":"﷼"},"ISK":{"symbol":"Ikr","symbol_native":"kr"},"JMD":{"symbol":"J$","symbol_native":"$"},"JOD":{"symbol":"JD","symbol_native":"د.أ.‏"},"JPY":{"symbol":"¥","symbol_native":"￥"},"KES":{"symbol":"Ksh","symbol_native":"Ksh"},"KHR":{"symbol":"KHR","symbol_native":"៛"},"KMF":{"symbol":"CF","symbol_native":"FC"},"KRW":{"symbol":"₩","symbol_native":"₩"},"KWD":{"symbol":"KD","symbol_native":"د.ك.‏"},"KZT":{"symbol":"KZT","symbol_native":"тңг."},"LBP":{"symbol":"LB£","symbol_native":"ل.ل.‏"},"LKR":{"symbol":"SLRs","symbol_native":"SL Re"},"LTL":{"symbol":"Lt","symbol_native":"Lt"},"LVL":{"symbol":"Ls","symbol_native":"Ls"},"LYD":{"symbol":"LD","symbol_native":"د.ل.‏"},"MAD":{"symbol":"MAD","symbol_native":"د.م.‏"},"MDL":{"symbol":"MDL","symbol_native":"MDL"},"MGA":{"symbol":"MGA","symbol_native":"MGA"},"MKD":{"symbol":"MKD","symbol_native":"MKD"},"MMK":{"symbol":"MMK","symbol_native":"K"},"MOP":{"symbol":"MOP$","symbol_native":"MOP$"},"MUR":{"symbol":"MURs","symbol_native":"MURs"},"MXN":{"symbol":"MX$","symbol_native":"$"},"MYR":{"symbol":"RM","symbol_native":"RM"},"MZN":{"symbol":"MTn","symbol_native":"MTn"},"NAD":{"symbol":"N$","symbol_native":"N$"},"NGN":{"symbol":"₦","symbol_native":"₦"},"NIO":{"symbol":"C$","symbol_native":"C$"},"NOK":{"symbol":"Nkr","symbol_native":"kr"},"NPR":{"symbol":"NPRs","symbol_native":"नेरू"},"NZD":{"symbol":"NZ$","symbol_native":"$"},"OMR":{"symbol":"OMR","symbol_native":"ر.ع.‏"},"PAB":{"symbol":"B/.","symbol_native":"B/."},"PEN":{"symbol":"S/.","symbol_native":"S/."},"PHP":{"symbol":"₱","symbol_native":"₱"},"PKR":{"symbol":"PKRs","symbol_native":"₨"},"PLN":{"symbol":"zł","symbol_native":"zł"},"PYG":{"symbol":"₲","symbol_native":"₲"},"QAR":{"symbol":"QR","symbol_native":"ر.ق.‏"},"RON":{"symbol":"RON","symbol_native":"RON"},"RSD":{"symbol":"din.","symbol_native":"дин."},"RUB":{"symbol":"RUB","symbol_native":"руб."},"RWF":{"symbol":"RWF","symbol_native":"FR"},"SAR":{"symbol":"SR","symbol_native":"ر.س.‏"},"SDG":{"symbol":"SDG","symbol_native":"SDG"},"SEK":{"symbol":"Skr","symbol_native":"kr"},"SGD":{"symbol":"S$","symbol_native":"$"},"SOS":{"symbol":"Ssh","symbol_native":"Ssh"},"SYP":{"symbol":"SY£","symbol_native":"ل.س.‏"},"THB":{"symbol":"฿","symbol_native":"฿"},"TND":{"symbol":"DT","symbol_native":"د.ت.‏"},"TOP":{"symbol":"T$","symbol_native":"T$"},"TRY":{"symbol":"TL","symbol_native":"TL"},"TTD":{"symbol":"TT$","symbol_native":"$"},"TWD":{"symbol":"NT$","symbol_native":"NT$"},"TZS":{"symbol":"TSh","symbol_native":"TSh"},"UAH":{"symbol":"₴","symbol_native":"₴"},"UGX":{"symbol":"USh","symbol_native":"USh"},"UYU":{"symbol":"$U","symbol_native":"$"},"UZS":{"symbol":"UZS","symbol_native":"UZS"},"VEF":{"symbol":"Bs.F.","symbol_native":"Bs.F."},"VND":{"symbol":"₫","symbol_native":"₫"},"XAF":{"symbol":"FCFA","symbol_native":"FCFA"},"XOF":{"symbol":"CFA","symbol_native":"CFA"},"YER":{"symbol":"YR","symbol_native":"ر.ي.‏"},"ZAR":{"symbol":"R","symbol_native":"R"},"ZMK":{"symbol":"ZK","symbol_native":"ZK"}}');
			
			self::$image_url = plugins_url('ultimate_crypto_widgets/assets/coin-logos/');
			
            add_action( 'init', array( $this, 'init' ) );
		}

		public function init() {

			if(is_admin()) {
				add_action( 'admin_enqueue_scripts', array( $this, 'adminEnqueueScripts' ) );
			}
			add_action( 'wp_enqueue_scripts', array( $this, 'enqueueScripts' ) );
			
			// add_action( 'wp_ajax_rc_cache_history24h', array($this, 'cacheHistory') );
			// add_action( 'wp_ajax_nopriv_rc_cache_history24h', array($this, 'cacheHistory') );

        }

		public function adminEnqueueScripts() {
		
		}

		public function enqueueScripts() {
			
        }
		
		public static function render($type, $coins, $css = '') {
			switch ($type) {
				case 'image':
					return '<span class="'.esc_attr($css).'" data-coin-image="'.strtoupper(str_replace("*","_",$coins)).'"></span>';
					break;
				case 'longName':
					return '<span class="'.esc_attr($css).'" data-coin-long-name="'.strtoupper(str_replace("*","_",$coins)).'"></span>';
					break;
				case 'shortName':
					return '<span class="'.esc_attr($css).'" data-coin-short-name="'.strtoupper(str_replace("*","_",$coins)).'"></span>';
					break;	
				default:
					# code...
					break;
			}
			
        }
		
		public function cacheHistory($force){
			$history = get_option(BESTBUG_CRYPTO_PREFIX . 'history24h');
			if(!is_array($history) || count($history) <= 0 || $force == true) {
				$coins = BESTBUG_CRYPTO_HELPER::coinList();
				$history = array();
				if(is_array($coins)) {
					foreach ($coins as $key => $coin) {
						$data = BESTBUG_CRYPTO_HELPER::getHistory($coin);
						if($data) {
							array_push($history, array($coin => $data));
						} else {
							for ($i = 0; $i < 100; $i++) { 
								$data = BESTBUG_CRYPTO_HELPER::getHistory($coin);
								if($data) {
									array_push($history, array($coin => $data));
									break;
								}
							}
						}
					}
				}
				BESTBUG_HELPER::update_option(BESTBUG_CRYPTO_PREFIX . 'history24h', $history);
			}
			return $history;
		}
		
		public function getHistory($coin){
			$chart24h = array();
			$data = json_decode(file_get_contents('https://min-api.cryptocompare.com/data/histohour?fsym='.$coin.'&tsym=USD&limit=23&aggregate=3&e=CCCAGG'));
			if(is_array($data) && isset($data->Data)) {
				foreach ($data->Data as $key => $data) {
					array_push($chart24h, $data->close);
				}
			} else {
				return false;
			}
			return implode(',', $chart24h);
		}
		
		public static function getHistory7d($coin, $isData = true){
			$chart7d = get_option(BESTBUG_CRYPTO_PREFIX . 'chart7d');
			$time = time();
			
			if(isset($chart7d[$coin]['time']) && $time - $chart7d[$coin]['time'] < 24 * 60 * 60 ) {
				if($isData) {
					return implode(',', $chart7d[$coin]['chart7d']['close']);
				} else {
					return implode(',', $chart7d[$coin]['chart7d']['time']);
				}
			
			}
			
			if(!is_array($chart7d)) {
				$chart7d = array();
			}
			
			$data = json_decode(file_get_contents('https://min-api.cryptocompare.com/data/histoday?fsym='.$coin.'&tsym=USD&limit=6&aggregate=3&e=CCCAGG'));
			if(isset($data->Data)) {
				$chart7d[$coin]['chart7d'] = array();
				foreach ($data->Data as $key => $data) {
					$chart7d[$coin]['chart7d']['close'][] = $data->close;
					$chart7d[$coin]['chart7d']['time'][] = $data->time;
				}
				$chart7d[$coin]['time'] = time();
			} else {
				$chart7d[$coin]['chart7d']['close'][] = 0;
				$chart7d[$coin]['chart7d']['time'][] = 0;
			}
			
			BESTBUG_HELPER::update_option(BESTBUG_CRYPTO_PREFIX . 'chart7d', $chart7d);
			if($isData) {
				return implode(',', $chart7d[$coin]['chart7d']['close']);
			} else {
				return implode(',', $chart7d[$coin]['chart7d']['time']);
			}
		}
		
		public static function format_money($money = 0){
			$suffix = '';
			if($money > 1000000000) {
				$money = $money/1000000000;
				$symbol = get_option(BESTBUG_CRYPTO_PREFIX . 'billion_symbol');
				$suffix = (isset($symbol) && !empty($symbol)) ? ' '.$symbol : ' B';
			} elseif($money > 1000000) {
				$money = $money/1000000;
				$symbol = get_option(BESTBUG_CRYPTO_PREFIX . 'million_symbol');
				$suffix = (isset($symbol) && !empty($symbol)) ? ' '.$symbol : ' M';
			} elseif($money > 1000) {
				$money = $money/1000;
				$symbol = get_option(BESTBUG_CRYPTO_PREFIX . 'thousand_symbol');
				$suffix = (isset($symbol) && !empty($symbol)) ? ' '.$symbol : ' K';
			} 
			$money = (strlen(substr(strrchr($money, "."), 1)) > 2 && $money > 1)?number_format($money, 2, '.', ','):$money;
			return $money . $suffix;
		}
		
		public static function row($start = 0, $limit = 20){
			$symbols = self::$currencies_symbol;
			$show_sparkchart24h = get_option(BESTBUG_CRYPTO_PREFIX . 'show_sparkchart24h');
			$dataCoins = '';
			// $chart24h = get_option(BESTBUG_CRYPTO_PREFIX . 'chart24h');
			$prefix = get_option(BESTBUG_CRYPTO_PREFIX . 'currency');
			$rates = BESTBUG_CRYPTO_HELPER::cacheRates();
			$rate = 1;
			if(isset($rates[$prefix])) {
				$rate = $rates[$prefix];
			}
			if(isset($symbols->{$prefix})) {
				$prefix = $symbols->{$prefix}->symbol_native . ' ';
			}
			$time = time();
			$data = json_decode(file_get_contents('https://api.coinmarketcap.com/v1/ticker/?start='.$start.'&limit='.$limit));
			
			if(!is_array($data) && isset($data[0]->id)) {
				return false;
			}
			
			foreach ($data as $key => $coin) {
				$coins = $coin->symbol;
				$detail_url = $detail_url_end = '';
				$coin->price_usd = $coin->price_usd * $rate;
				
				$price = $coin->price_usd;
				if($price > 1) {
					$price = number_format($coin->price_usd, 2, '.', ',');
				} elseif($price > 0.0001) {
					$price = number_format($coin->price_usd, 4, '.', ',');
				}
				
				//$price = (strlen(substr(strrchr($coin->price_usd, "."), 1)) > 4 && $coin->price_usd > 1)?number_format($coin->price_usd, 4, '.', ','):$coin->price_usd;
				
				$css_change24h = ($coin->percent_change_24h >= 0)?'rc-up-color':'rc-down-color';
				$coin->percent_change_24h = ($coin->percent_change_24h != '')?$coin->percent_change_24h:'0.00';
				
				$dataChart24h = '';
				// if(isset($chart24h[$coins]['time']) && $time - $chart24h[$coins]['time'] < 60 * 60 ) {
				// 	$dataChart24h = '['.implode(',', $chart24h[$coins]['chart24h']).']';
				// }
				if($show_sparkchart24h != 'no') {
					$dataChart24h = '<span data-chart24h="'.$coins.'" data-chart24h-data="'.$dataChart24h.'"></span>';
				}
				
				$dataCoins .= '<tr class="rc-wrap-price rc-wrap-PRICE-'.$coins.'">
							<td>'.$coin->rank.'</td>
							<td class="rc-coin-name">
								<a data-detail-coin="'.$coins.'" class="rc-detal-coin" href="javascript:;">
									<span class="rc-image-'.strtoupper(str_replace("*","_",$coins)).'" data-coin-image="'.strtoupper(str_replace("*","_",$coins)).'"></span>
									<span class="rc-coinname-'.$coins.'">'.$coin->name.'</span>
									<span class="rc-mobile-show">'.strtoupper(str_replace("*","_",$coins)).'</span>
								</a>
							</td>
							<td data-order="'.$coin->price_usd.'">
								<span class="rc-highlight rc-PRICE-'.$coins.'" data-live-price="'.$coins.'">
									'.$prefix.$price.'
								</span>
							</td>
							<td data-order="'.$coin->available_supply.'">
								<span class="rc-supply-'.$coins.'">'.BESTBUG_CRYPTO_HELPER::format_money($coin->available_supply).' ('.$coin->symbol.')</span>
							</td>
							<td data-order="'.$coin->{'24h_volume_usd'}.'">
								<span class="rc-volumn-'.$coins.'">'.$prefix.BESTBUG_CRYPTO_HELPER::format_money($coin->{'24h_volume_usd'} * $rate).'</span>
							</td>
							<td data-order="'.$coin->market_cap_usd.'">
								<span class="rc-MKTCAP-'.$coins.'">'.$prefix.BESTBUG_CRYPTO_HELPER::format_money($coin->market_cap_usd * $rate).'</span>
							</td>
							<td data-order="'.$coin->percent_change_24h.'">
								<span class="rc-wrap-perc '.$css_change24h.'" data-live-perc="'.$coins.'">'.$coin->percent_change_24h.'%</span>
								'.$dataChart24h.'
							</td>
						</tr>';
			}
			return $dataCoins;
		}
		
		public static function cacheCurrency($force = false) {
			$all_currency = get_option(BESTBUG_CRYPTO_PREFIX . 'all_currency');
			if(!is_array($all_currency) || count($all_currency) <= 0 || $force == true) {
				$all_currency = array();
				$data = json_decode(file_get_contents('https://openexchangerates.org/api/currencies.json'));
				if(isset($data->USD)) {
					foreach ($data as $key => $name) {
						$all_currency[$key] = $key . ' - ' . $name;
					}
					BESTBUG_HELPER::update_option(BESTBUG_CRYPTO_PREFIX . 'all_currency', $all_currency);
				}
			}
			return $all_currency;
        }
		
		public static function cacheRates($force = false) {
			$rates = get_option(BESTBUG_CRYPTO_PREFIX . 'rates');
			$time = time();
			if(isset($rates['time']) && $time - $rates['time'] < 1 * 60 * 60 ) {
				return $rates['data'];
			}
			
			$api = get_option(BESTBUG_CRYPTO_PREFIX . 'openexchangerates');
			if(!$api) {
				$api = '8c4ddb87246a4149a1348fb751a2ac77';
			}
			//if(!is_array($rates) || count($rates) <= 0 || $force == true) {
				$rates = array();
				$data = json_decode(file_get_contents('https://openexchangerates.org/api/latest.json?app_id='.$api));
				if(isset($data->rates)) {
					foreach ($data->rates as $key => $value) {
						$rates['data'][$key] = $value;
					}
					$rates['time'] = $time;
					BESTBUG_HELPER::update_option(BESTBUG_CRYPTO_PREFIX . 'rates', $rates);
				}
			//}
			return $rates['data'];
        }
		
		public static function cacheCoinlist($force = false) {
			$coins = get_option(BESTBUG_CRYPTO_PREFIX . 'coins');
			if(!is_array($coins) || count($coins) <= 0 || $force == true) {
				$data = json_decode( file_get_contents('https://api.coinmarketcap.com/v1/ticker/?limit=0') );
				$coins = array();
				if(isset($data) && !empty($data) ) {
					foreach ($data as $key => $coin) {
						$coins[$coin->symbol] = $coin->name;
						BESTBUG_HELPER::update_option(BESTBUG_CRYPTO_PREFIX . 'coins', $coins);
					}
				}
			}
			
			return $coins;
		}
		
		public static function coinImages() {
			ob_start();
			include 'const/coinimages.const.php';
			$images = ob_get_contents(); 
			ob_end_clean();
			return json_decode($images, true);
		}
		
		public static function coinList() {
			ob_start();
			include 'const/coins.const.php';
			$coins = ob_get_contents(); 
			ob_end_clean();
			return json_decode($coins, true);
		}
		
		public static function cacheCoinImages($force = false) {
			$images = get_option(BESTBUG_CRYPTO_PREFIX . 'images');
			
			// $images = array();
			// $data = json_decode( file_get_contents('https://api.coinmarketcap.com/v1/ticker/?limit=0') );
			// foreach ($data as $key => $value) {
			// 	$images[$value->symbol] = $value->id . '.svg';
			// }
			// print_r($images);
			// 
			// die;
			
			if(!is_array($images) || count($images) <= 0 || $force == true) {
				$coins = self::coinList();
				$images = array();
				if(is_array($coins) || count($coins) > 0) {
					$data = json_decode(file_get_contents('https://min-api.cryptocompare.com/data/all/coinlist'));
					//var_dump($data->BaseImageUrl);die;
					if(!isset($data->BaseImageUrl)) {
						$data = json_decode(file_get_contents(BESTBUG_CRYPTO_FULLPATH . 'assets/json/coinlist.json'));
					}
					if(isset($data->BaseImageUrl)) {
						// foreach ($coins as $key => $coin) {
						// 	$images[$key] = $data->Data->{$key}->ImageUrl;
						// }
						foreach ($data->Data as $key => $value) {
							$images[strtoupper(str_replace("*","_",$key))] = strtolower(str_replace(" ","-",$value->CoinName)) . '.svg' ;
						}
						echo '<pre>';
						print_r(json_encode($images));
						echo '</pre>';
						
						die;
						// BESTBUG_HELPER::update_option(BESTBUG_CRYPTO_PREFIX . 'BaseImageUrl', $data->BaseImageUrl);
						// BESTBUG_HELPER::update_option(BESTBUG_CRYPTO_PREFIX . 'images', $images);
					} else {
						return false;
					}
				}
			}
			
			return $images;
		}

    }
	
	new BESTBUG_CRYPTO_HELPER();
}

