<?php
// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die;
}

if ( ! class_exists( 'BESTBUG_CRYPTO_POSTTYPES' ) ) {
	/**
	 * BESTBUG_CRYPTO_POSTTYPES Class
	 *
	 * @since	1.0
	 */
	class BESTBUG_CRYPTO_POSTTYPES {


		/**
		 * Constructor
		 *
		 * @return	void
		 * @since	1.0
		 */
		function __construct() {
			//$this->init();
			add_filter( 'bb_register_posttypes', array( $this, 'register_posttypes' ), 10, 1 );
		}

		public function init() {

			if(is_admin()) {
				add_action( 'admin_enqueue_scripts', array( $this, 'adminEnqueueScripts' ) );
			}
			add_action( 'wp_enqueue_scripts', array( $this, 'enqueueScripts' ) );

        }

		public function adminEnqueueScripts() {
		
		}

		public function enqueueScripts() {
		
        }
        
		public function register_posttypes($posttypes) {

			if( empty($posttypes) ) {
				$posttypes = array();
			}

			$labels = array(
				'name'               => _x( 'Ultimate Crypto Widgets Shortcodes', 'Ultimate Crypto Widgets Shortcodes', 'bestbug' ),
				'singular_name'      => _x( 'Ultimate Crypto Widgets Shortcode', 'Ultimate Crypto Widgets Shortcode', 'bestbug' ),
				'menu_name'          => esc_html__( 'Ultimate Crypto Widgets Shortcode', 'bestbug' ),
				'name_admin_bar'     => esc_html__( 'Ultimate Crypto Widgets Shortcode', 'bestbug' ),
				'parent_item_colon'  => esc_html__( 'Parent Menu:', 'bestbug' ),
				'all_items'          => esc_html__( 'All Ultimate Crypto Widgets Shortcodes', 'bestbug' ),
				'add_new_item'       => esc_html__( 'Add New Ultimate Crypto Widgets Shortcode', 'bestbug' ),
				'add_new'            => esc_html__( 'Add New', 'bestbug' ),
				'new_item'           => esc_html__( 'New Ultimate Crypto Widgets Shortcode', 'bestbug' ),
				'edit_item'          => esc_html__( 'Edit Ultimate Crypto Widgets Shortcode', 'bestbug' ),
				'update_item'        => esc_html__( 'Update Ultimate Crypto Widgets Shortcode', 'bestbug' ),
				'view_item'          => esc_html__( 'View Ultimate Crypto Widgets Shortcode', 'bestbug' ),
				'search_items'       => esc_html__( 'Search Ultimate Crypto Widgets Shortcode', 'bestbug' ),
				'not_found'          => esc_html__( 'Not found', 'bestbug' ),
				'not_found_in_trash' => esc_html__( 'Not found in Trash', 'bestbug' ),
			);
			$args   = array(
				'label'               => esc_html__( 'Ultimate Crypto Widgets Shortcode', 'bestbug' ),
				'description'         => esc_html__( 'Ultimate Crypto Widgets Shortcode', 'bestbug' ),
				'labels'              => $labels,
				'supports'            => array( 'title', 'editor', ),
				'hierarchical'        => false,
				'public'              => false,
				'show_ui'             => false,
				'show_in_menu'        => false,
				'menu_position'       => 13,
				'menu_icon'           => 'dashicons-schedule',
				'show_in_admin_bar'   => false,
				'show_in_nav_menus'   => false,
				'can_export'          => true,
				'has_archive'         => false,
				'exclude_from_search' => true,
				'publicly_queryable'  => false,
				'rewrite'             => false,
				'capability_type'     => 'page',
			);
			$posttypes[BESTBUG_CRYPTO_POSTTYPE] = $args;
			return $posttypes;
		}
        
    }
	
	new BESTBUG_CRYPTO_POSTTYPES();
}

