<?php
// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die;
}

if ( ! class_exists( 'BESTBUG_CRYPTO_CHART_SHORTCODE' ) ) {
	/**
	 * BESTBUG_CRYPTO_CHART_SHORTCODE Class
	 *
	 * @since	1.0
	 */
	class BESTBUG_CRYPTO_CHART_SHORTCODE {

		/**
		 * Constructor
		 *
		 * @return	void
		 * @since	1.0
		 */
		function __construct() {
			$this->init();
		}

		public function init() {
			
			add_shortcode( BESTBUG_CRYPTO_CHART_SHORTCODE, array( $this, 'shortcode' ) );
			if ( defined( 'WPB_VC_VERSION' ) && function_exists( 'vc_add_param' ) ) {
				$this->vc_shortcode();
			}

			if(is_admin()) {
				add_action( 'admin_enqueue_scripts', array( $this, 'adminEnqueueScripts' ) );
			}
			add_action( 'wp_enqueue_scripts', array( $this, 'enqueueScripts' ) );

        }

		public function adminEnqueueScripts() {
			// wp_enqueue_style( 'css', BESTBUG_CRYPTO_URL . '/assets/admin/css/style.css' );
			// wp_enqueue_script( 'js', BESTBUG_CRYPTO_URL . '/assets/admin/js/script.js', array( 'jquery' ), '1.0', true );
			
		}

		public function enqueueScripts() {
			// wp_enqueue_style( 'css', BESTBUG_CRYPTO_URL . '/assets/css/style.css' );
			// wp_enqueue_script( 'js', BESTBUG_CRYPTO_URL . '/assets/js/script.js', array( 'jquery' ), '1.0', true );
		}
        
        public function vc_shortcode() {
			
        }
		
		public function shortcode( $atts, $content = null ) {
			shortcode_atts( array(
				'only_coins' => '',
				'high_light' => 'yes',
				'skin' => '',
			), $atts );
			
			$dataCoins = '';
			$container_class = array(
				'realcrypto',
				'realcrypto-chart-wrap',
			);
			
			$chartSkin = '';
			if(isset($atts['skin'])) {
				$container_class[] = 'rc-color-' . $atts['skin'];
				$chartSkin = $atts['skin'];
			}
			if(isset($atts['high_light']) && $atts['high_light'] == 'yes') {
				$container_class[] = 'rc-highlight';
			}
			
			
			if(isset($atts['only_coins']) && !empty($atts['only_coins'])) {
				$only_coins = explode(',', $atts['only_coins']);
				if(is_array($only_coins) && count($only_coins) > 0) {
					foreach ($only_coins as $key => $coins) {
						if(array_key_exists( $coins, BESTBUG_CRYPTO_HELPER::$alias)) {
							$coins = BESTBUG_CRYPTO_HELPER::$alias[$coins];
						}
						$dataCoins .= '
						<div class="rc-single-chart-wrap" data-coin="'.$coins.'">
							<div class="rc-chart-title">
								<div class="rc-pos-left">
									<span class="rc-image-'.$coins.'"></span>
									<span class="rc-coinname-'.$coins.'"></span> 
									( <span class="rc-name-'.$coins.'"></span> ) 
								</div>
								<div class="rc-pos-right">
									<span class="rc-highlight rc-wrap-PRICE-'.$coins.' rc-PRICE-'.$coins.'"></span> 
									( <span class="rc-highlight rc-wrap-CHANGE24HOURPCT-'.$coins.' rc-CHANGE24HOURPCT-'.$coins.'"></span> )
									<div class="rc-sub-info">
										<div>
											<span class="rc-label">'.esc_html('Hightest 24h', 'bestbug').'</span>
											<span class="rc-HIGH24HOUR-'.$coins.'"></span>
										</div>
										<div>
											<span class="rc-label">'.esc_html('Lowest 24h', 'bestbug').'</span>
											<span class="rc-LOW24HOUR-'.$coins.'"></span>
										</div>
										<div>
											<span class="rc-label">'.esc_html('Change 24h', 'bestbug').'</span>
											<span class="rc-wrap-CHANGE24HOUR-'.$coins.' rc-CHANGE24HOUR-'.$coins.' rc-highlight"></span>
										</div>
									</div>
								</div>
							</div>
							<canvas class="rc-chart-large rc-chart-'.$coins.'" id="'.uniqid('rc-').'" data-chart-coin="'.$coins.'" data-color="'.$chartSkin.'" data-chart="'.BESTBUG_CRYPTO_HELPER::getHistory7d($coins).'" data-chart-labels="'.BESTBUG_CRYPTO_HELPER::getHistory7d($coins, false).'"></canvas>
						</div>';
					}
				}
			}
			
			return '<div class="'.implode(" ", $container_class).'">
						<div class="realcrypto-chart-inside">
							'.$dataCoins.'
			        	</div>
					</div>';
		}
        
    }
	
	new BESTBUG_CRYPTO_CHART_SHORTCODE();
}

