<?php
// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die;
}

if ( ! class_exists( 'BESTBUG_CRYPTO_CONVERT_SHORTCODE' ) ) {
	/**
	 * BESTBUG_CRYPTO_CONVERT_SHORTCODE Class
	 *
	 * @since	1.0
	 */
	class BESTBUG_CRYPTO_CONVERT_SHORTCODE {

		/**
		 * Constructor
		 *
		 * @return	void
		 * @since	1.0
		 */
		function __construct() {
			$this->init();
		}

		public function init() {
			
			add_action( 'wp_ajax_rc_list_convert', array($this, 'ajax_get_list_convert') );
			add_action( 'wp_ajax_nopriv_rc_list_convert', array($this, 'ajax_get_list_convert') );
			add_action( 'wp_ajax_rc_get_convert', array($this, 'ajax_get_convert') );
			add_action( 'wp_ajax_nopriv_rc_get_convert', array($this, 'ajax_get_convert') );
			
			add_shortcode( BESTBUG_CRYPTO_CONVERT_SHORTCODE, array( $this, 'shortcode' ) );
			if ( defined( 'WPB_VC_VERSION' ) && function_exists( 'vc_add_param' ) ) {
				$this->vc_shortcode();
			}

			if(is_admin()) {
				add_action( 'admin_enqueue_scripts', array( $this, 'adminEnqueueScripts' ) );
			}
			add_action( 'wp_enqueue_scripts', array( $this, 'enqueueScripts' ) );

        }

		public function adminEnqueueScripts() {
			// wp_enqueue_style( 'css', BESTBUG_CRYPTO_URL . '/assets/admin/css/style.css' );
			// wp_enqueue_script( 'js', BESTBUG_CRYPTO_URL . '/assets/admin/js/script.js', array( 'jquery' ), '1.0', true );
			
		}

		public function enqueueScripts() {
			// wp_enqueue_style( 'css', BESTBUG_CRYPTO_URL . '/assets/css/style.css' );
			// wp_enqueue_script( 'js', BESTBUG_CRYPTO_URL . '/assets/js/script.js', array( 'jquery' ), '1.0', true );
		}
        
        public function vc_shortcode() {
			
        }
		
		public function ajax_get_list_convert() {
			$list = '';
			$coins = BESTBUG_CRYPTO_HELPER::coinList();
			$currency = BESTBUG_CRYPTO_HELPER::cacheCurrency();
			
			if(isset($coins)) {
				echo json_encode(array(
					'status' => 'ok',
					'coins' => $coins,
					'currency' => $currency,
				));
				die;
			}
			echo json_encode(array(
				'status' => 'error',
			));
			exit;
        }
		
		public function ajax_get_convert() {
			$from = $_POST['from'];
			$to = $_POST['to'];
			if(!empty($to) && !empty($from)) {
				$result = file_get_contents('https://min-api.cryptocompare.com/data/pricemulti?fsyms='.$from.'&tsyms='.$to);
				echo json_encode(array(
					'status' => 'ok',
					'result' => json_decode($result),
				));
				die;
			}
			echo json_encode(array(
				'status' => 'error',
			));
			exit;
        }
		
		public function shortcode( $atts, $content = null ) {
			shortcode_atts( array(
				'shape' => '',
				'skin' => '',
				'el_class' => '',
			), $atts );
			
			$attsData = '';
			$container_class = array(
				'realcrypto',
				'realcrypto-convert-wrap',
			);
			
			if(isset($atts['skin']) && !empty($atts['skin'])) {
				$container_class[] = 'rc-color-'.$atts['skin'];
			}
			if(isset($atts['shape']) && !empty($atts['shape'])) {
				$container_class[] = 'rc-shape-'.$atts['shape'];
			}
			
			if(isset($_GET[BESTBUG_CRYPTO_QUERYVAR]) && !empty($_GET[BESTBUG_CRYPTO_QUERYVAR])) {
				$attsData .= 'data-convert-coin="'.$_GET[BESTBUG_CRYPTO_QUERYVAR].'" ';
			} else {
				$attsData .= 'data-convert-coin="BTC" ';
			}
			
			return '<div class="'.implode(" ", $container_class).'" '.$attsData.'>
						<div class="realcrypto-convert-inside">
							<div class="rc-pos-left">
								<span><input class="rc-input rc-amount" type="number" min="0" placeholder="'.esc_html('Enter Amount to Convert', 'bestbug').'" /></span>
								<span><select class="rc-coins-data"></select></span>
							</div>
							<div class="rc-pos-center">
								<div><span class="dashicons dashicons-arrow-right-alt"></span></div>
								<div><span class="rc-btn-exchange"><span class="dashicons dashicons-update"></span></span></div>
							</div>
							<div class="rc-pos-right">
								<span><input class="rc-input rc-result" disabled="disabled" type="text" placeholder="" /></span>
								<span><select class="rc-currency-data"></select></span>
							</div>
						</div>
					</div>';
		}
        
    }
	
	new BESTBUG_CRYPTO_CONVERT_SHORTCODE();
}

