<?php
// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die;
}

if ( ! class_exists( 'BESTBUG_CRYPTO_INLINE_SHORTCODE' ) ) {
	/**
	 * BESTBUG_CRYPTO_INLINE_SHORTCODE Class
	 *
	 * @since	1.0
	 */
	class BESTBUG_CRYPTO_INLINE_SHORTCODE {

		/**
		 * Constructor
		 *
		 * @return	void
		 * @since	1.0
		 */
		function __construct() {
			$this->init();
		}

		public function init() {
			
			add_shortcode( BESTBUG_CRYPTO_INLINE_SHORTCODE, array( $this, 'shortcode' ) );
			if ( defined( 'WPB_VC_VERSION' ) && function_exists( 'vc_add_param' ) ) {
				$this->vc_shortcode();
			}

			if(is_admin()) {
				add_action( 'admin_enqueue_scripts', array( $this, 'adminEnqueueScripts' ) );
			}
			add_action( 'wp_enqueue_scripts', array( $this, 'enqueueScripts' ) );

        }

		public function adminEnqueueScripts() {
			// wp_enqueue_style( 'css', BESTBUG_CRYPTO_URL . '/assets/admin/css/style.css' );
			// wp_enqueue_script( 'js', BESTBUG_CRYPTO_URL . '/assets/admin/js/script.js', array( 'jquery' ), '1.0', true );
			
		}

		public function enqueueScripts() {
			// wp_enqueue_style( 'css', BESTBUG_CRYPTO_URL . '/assets/css/style.css' );
			// wp_enqueue_script( 'js', BESTBUG_CRYPTO_URL . '/assets/js/script.js', array( 'jquery' ), '1.0', true );
		}
        
        public function vc_shortcode() {
			
        }
		
		public function shortcode( $atts, $content = null ) {
			shortcode_atts( array(
				'inline_fields' => '',
				'only_coins' => '',
				'high_light' => 'yes',
				'skin' => '',
			), $atts );
			
			$container_class = array(
				'realcrypto',
				'realcrypto-inline-wrap',
				
			);
			
			if(isset($atts['skin']) && !empty($atts['skin'])) {
				$container_class[] = 'rc-color-'.$atts['skin'];
			}
			if(isset($atts['high_light']) && $atts['high_light'] == 'yes') {
				$container_class[] = 'rc-highlight';
			}
			
			$dataCoins = '';
			
			if(isset($atts['only_coins']) && !empty($atts['only_coins'])) {
				$only_coins = explode(',', $atts['only_coins']);
				$inline_fields = explode(',', $atts['inline_fields']);
				if(is_array($only_coins) && count($only_coins) > 0) {
					foreach ($only_coins as $key => $coins) {
						if(array_key_exists( $coins, BESTBUG_CRYPTO_HELPER::$alias)) {
							$coins = BESTBUG_CRYPTO_HELPER::$alias[$coins];
						}
						$dataCoins .= '<span class="rc-single-inline-wrap" data-coin="'.$coins.'">';
						
						if(in_array('icon', $inline_fields)) {
							$dataCoins .= '<span class="rc-image-'.$coins.'"></span> ';
						} 
						if(in_array('long', $inline_fields)){
							$dataCoins .= '<span class="rc-coinname-'.$coins.'"></span>';
						}  
						if(in_array('short', $inline_fields)){
							$dataCoins .= '<strong>
								<span class="rc-name-'.$coins.'"></span>
							</strong> ';
						}  
						if(in_array('price', $inline_fields)){
							$dataCoins .= '<span class="rc-wrap-PRICE-'.$coins.' rc-PRICE-'.$coins.'"></span> ';
						}  
						if(in_array('arrow', $inline_fields)){
							$dataCoins .= '<span class="rc-wrap-CHANGE24HOUR-'.$coins.' rc-arrow-up rc-up-color dashicons dashicons-arrow-up-alt"></span>
							<span class="rc-wrap-CHANGE24HOUR-'.$coins.' rc-arrow-down rc-down-color dashicons dashicons-arrow-down-alt"></span> ';
						}  
						
						if(in_array('change24h', $inline_fields) || in_array('change24hptc', $inline_fields)){
							$dataCoins .= '(';
						}
						if(in_array('change24h', $inline_fields)){
							$dataCoins .= '<span class="rc-wrap-CHANGE24HOUR-'.$coins.' rc-CHANGE24HOUR-'.$coins.'"></span> ';
						}  
						if(in_array('change24hptc', $inline_fields)){
							$dataCoins .= '<span class="rc-wrap-CHANGE24HOURPCT-'.$coins.' rc-CHANGE24HOURPCT-'.$coins.'"></span>';
						}
						if(in_array('change24h', $inline_fields) || in_array('change24hptc', $inline_fields)){
							$dataCoins .= ')';
						}
							
						$dataCoins .= '</span>';
						
					}
				}
			}
			
			return '<span class="'.implode(" ", $container_class).'">
						'.$dataCoins.'
					</span>';
		}
        
    }
	
	new BESTBUG_CRYPTO_INLINE_SHORTCODE();
}

