<?php
// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die;
}

if ( ! class_exists( 'BESTBUG_CRYPTO_LEADERBOARD_SHORTCODE' ) ) {
	/**
	 * BESTBUG_CRYPTO_LEADERBOARD_SHORTCODE Class
	 *
	 * @since	1.0
	 */
	class BESTBUG_CRYPTO_LEADERBOARD_SHORTCODE {

		/**
		 * Constructor
		 *
		 * @return	void
		 * @since	1.0
		 */
		function __construct() {
			$this->init();
		}

		public function init() {
			
			add_shortcode( BESTBUG_CRYPTO_LEADERBOARD_SHORTCODE, array( $this, 'shortcode' ) );
			if ( defined( 'WPB_VC_VERSION' ) && function_exists( 'vc_add_param' ) ) {
				$this->vc_shortcode();
			}

			if(is_admin()) {
				add_action( 'admin_enqueue_scripts', array( $this, 'adminEnqueueScripts' ) );
			}
			add_action( 'wp_enqueue_scripts', array( $this, 'enqueueScripts' ) );

        }

		public function adminEnqueueScripts() {
			// wp_enqueue_style( 'css', BESTBUG_CRYPTO_URL . '/assets/admin/css/style.css' );
			// wp_enqueue_script( 'js', BESTBUG_CRYPTO_URL . '/assets/admin/js/script.js', array( 'jquery' ), '1.0', true );
			
		}

		public function enqueueScripts() {
			// wp_enqueue_style( 'css', BESTBUG_CRYPTO_URL . '/assets/css/style.css' );
			// wp_enqueue_script( 'js', BESTBUG_CRYPTO_URL . '/assets/js/script.js', array( 'jquery' ), '1.0', true );
		}
        
        public function vc_shortcode() {
			
        }
		
		public function shortcode( $atts, $content = null ) {
			shortcode_atts( array(
				'all_coins' => '',
				'only_coins' => '',
				'leaderboard_style' => '',
				'skin' => '',
				'shape' => '',
				'high_light' => '',
				'leaderboard_border' => '',
				'leaderboard_shadow' => ''
			), $atts );

			$table_atts = ''; $dataCoins = '<tbody>';
			$dataCoins = '';
			$container_class = array(
				'realcrypto',
				'realcrypto-leaderboard-wrap',
			);
			
			if(isset($atts['skin']) && !empty($atts['skin'])) {
				$container_class[] = 'rc-color-'.$atts['skin'];
			}
			if(isset($atts['leaderboard_style']) && !empty($atts['leaderboard_style'])) {
				$container_class[] = 'rc-leaderboard-style-'.$atts['leaderboard_style'];
			}
			if(isset($atts['shape']) && !empty($atts['shape'])) {
				$container_class[] = 'rc-leaderboardshape-'.$atts['shape'];
			}
			if(isset($atts['high_light']) && $atts['high_light'] == 'yes') {
				$container_class[] = 'rc-highlight';
			}
			if(isset($atts['leaderboard_shadow']) && $atts['leaderboard_shadow'] == 'yes') {
				$container_class[] = 'rc-leaderboard-shadow';
			}
			if(isset($atts['leaderboard_border']) && $atts['leaderboard_border'] == 'yes') {
				$container_class[] = 'rc-leaderboard-border';
			}
			
			if(isset($atts['only_coins']) && !empty($atts['only_coins'])) {
				$only_coins = explode(',', $atts['only_coins']);
				if(is_array($only_coins) && count($only_coins) > 0) {
					foreach ($only_coins as $key => $coins) {
						if(array_key_exists( $coins, BESTBUG_CRYPTO_HELPER::$alias)) {
							$coins = BESTBUG_CRYPTO_HELPER::$alias[$coins];
						}
						if($atts['leaderboard_style'] == 'advanced_1'):
							$dataCoins .= '<div class="rc-single-leaderboard-wrap" data-coin="'.$coins.'">
								<div class="wrapper-inside">
					                <div class="rc-info">
					                    <div class="rc-left-info">
											<span class="rc-image-'.$coins.'"></span>
					                        <span class="rc-name-'.$coins.'"></span>
				                            <div class="rc-price-wrap">
				                            	<span class="rc-highlight rc-wrap-PRICE-'.$coins.' rc-PRICE-'.$coins.'"></span>
												<span class="rc-wrap-CHANGE24HOUR-'.$coins.' rc-up-color rc-arrow-up dashicons dashicons-arrow-up-alt"></span>
												<span class="rc-wrap-CHANGE24HOUR-'.$coins.' rc-down-color rc-arrow-down dashicons dashicons-arrow-down-alt"></span>
				                            </div>
				                            <div>
				                            	<span class="rc-CHANGE24HOUR-'.$coins.'"></span>
												<span>/</span>
												<span class="rc-CHANGE24HOURPCT-'.$coins.'"></span>
											</div>
					                    </div>
					                    <div class="rc-right-param">
					                        <div class="elm-param">
					                            <div><b>Low 24h:</b> <span class="rc-LOW24HOUR-'.$coins.'"></span></div>
					                        </div>
					                        <div class="elm-param">
					                            <div><b>Hight 24h:</b> <span class="rc-HIGH24HOUR-'.$coins.'"></span></div>
					                        </div>
					                        <div class="elm-param">
					                            <div><b>Volume 24h:</b> <span class="rc-VOLUME24HOURTO-'.$coins.'"></span></div>
					                        </div>
					                        <div class="elm-param">
					                            <div><b>Total Vol. 24H:</b> <span class="rc-TOTALVOLUME24HTO-'.$coins.'"></span></div>
					                        </div>
					                        <div class="elm-param">
					                            <div><b>Market Cap:</b> <span class="rc-MKTCAP-'.$coins.'"></span></div>
					                        </div>
					                    </div>
					                </div>
					            </div>
							</div>';
						elseif($atts['leaderboard_style'] == 'advanced_2'):
							$dataCoins .= '<div class="rc-single-leaderboard-wrap" data-coin="'.$coins.'">
								<div class="rc-wrapper-inside">
									<div class="rc-info">
										<div class="rc-name">
											<span class="rc-image-'.$coins.'"></span>
											<span class="rc-coinname-'.$coins.'"></span>
											(<span class="rc-name-'.$coins.'"></span>)
										</div>
										<div class="rc-price">
											<span class="rc-highlight rc-wrap-PRICE-'.$coins.' rc-PRICE-'.$coins.'"></span>
											<span class="rc-wrap-CHANGE24HOUR-'.$coins.' rc-up-color rc-arrow-up dashicons dashicons-arrow-up-alt"></span>
											<span class="rc-wrap-CHANGE24HOUR-'.$coins.' rc-down-color rc-arrow-down dashicons dashicons-arrow-down-alt"></span>
										</div>
										<div class="rc-change-wrap">
											<span class="rc-wrap-CHANGE24HOUR-'.$coins.' rc-CHANGE24HOUR-'.$coins.'"></span>
											/
											<span class="rc-wrap-CHANGE24HOURPCT-'.$coins.' rc-CHANGE24HOURPCT-'.$coins.'"></span>
										</div>
										<div class="rc-more-param">
											<div class="elm-param">
					                            <div><b>Low 24h:</b> <span class="rc-LOW24HOUR-'.$coins.'"></span></div>
					                        </div>
					                        <div class="elm-param">
					                            <div><b>Hight 24h:</b> <span class="rc-HIGH24HOUR-'.$coins.'"></span></div>
					                        </div>
					                        <div class="elm-param">
					                            <div><b>Vol 24h:</b> <span class="rc-VOLUME24HOURTO-'.$coins.'"></span></div>
					                        </div>
					                        <div class="elm-param">
					                            <div><b>Total Vol. 24H:</b> <span class="rc-TOTALVOLUME24HTO-'.$coins.'"></span></div>
					                        </div>
										</div>
									</div>
								</div>
							</div>';
						endif;
					}
				}
			}
			
			return '<div class="'.implode(" ", $container_class).'">
						<div class="realcrypto-leaderboard-inside">
							'.$dataCoins.'
			        	</div>
					</div>';
		}
        
    }
	
	new BESTBUG_CRYPTO_LEADERBOARD_SHORTCODE();
}

