<?php
// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die;
}

if ( ! class_exists( 'BESTBUG_CRYPTO_TABLE_SHORTCODE' ) ) {
	/**
	 * BESTBUG_CRYPTO_TABLE_SHORTCODE Class
	 *
	 * @since	1.0
	 */
	class BESTBUG_CRYPTO_TABLE_SHORTCODE {

		/**
		 * Constructor
		 *
		 * @return	void
		 * @since	1.0
		 */
		function __construct() {
			$this->init();
		}

		public function init() {
			
			add_shortcode( BESTBUG_CRYPTO_TABLE_SHORTCODE, array( $this, 'shortcode' ) );
			if ( defined( 'WPB_VC_VERSION' ) && function_exists( 'vc_add_param' ) ) {
				$this->vc_shortcode();
			}

			if(is_admin()) {
				add_action( 'admin_enqueue_scripts', array( $this, 'adminEnqueueScripts' ) );
			}
			add_action( 'wp_enqueue_scripts', array( $this, 'enqueueScripts' ) );
			
			add_action( 'wp_ajax_ucw_table_list', array($this, 'table_list') );
			add_action( 'wp_ajax_nopriv_ucw_table_list', array($this, 'table_list') );
        }

		public function adminEnqueueScripts() {
		}

		public function enqueueScripts() {
		}
        
        public function vc_shortcode() {
			
        }
		
		public function table_list(){
			$start = (int)$_POST['start'];
			$limit = (int)$_POST['limit'];
			echo BESTBUG_CRYPTO_HELPER::row($start, $limit);
			exit;
		}
		
		public function shortcode( $atts, $content = null ) {
			shortcode_atts( array(
				'only_coins' => '',
				'all_coins' => '',
				
				// table option
				"paging" => 'no',
				"table_fields" => '',
				'pagelength' => '10',
		        "ordering" => 'yes',
		        "info" =>     'yes',
				'searching' => 'yes',
				// style
				'size' => 'small', // small, medium, large
				'hasBorder' => 'yes',
				'highLightRealtime' => 'yes',
				'hightLightEvenRow' => 'yes',
				'high_light' => 'yes',
				'skin' => '',
				'detail_url' => '',
			), $atts );
			
			//$table_fields = explode(',', $atts['table_fields']);
			$table_atts = ''; $dataCoins = '<tbody>';
			$container_class = array(
				'realcrypto',
				'realcrypto-table-wrap',
			);
			
			// Table style
			if(isset($atts['skin'])) {
				$container_class[] = 'rc-color-' . $atts['skin'];
				// $chartSkin = $atts['skin'];
			}
			if(isset($atts['size'])) {
				$container_class[] = 'rc-size-' . $atts['size'];
			}
			if(isset($atts[strtolower('hasBorder')]) && $atts[strtolower('hasBorder')] == 'yes') {
				$container_class[] = 'rc-hasBorder';
			} else if(isset($atts[strtolower('hightLightEvenRow')]) && $atts[strtolower('hightLightEvenRow')] == 'no') {
				$container_class[] = 'rc-hasBorder-bottom-row';
			}
			if(isset($atts['high_light']) && $atts['high_light'] == 'yes') {
				$container_class[] = 'rc-highlight';
			}
			//if(isset($atts['all_coins']) && $atts['all_coins'] == 'yes') {
				$container_class[] = 'realcrypto-all-coins';
			// } else {
			// 	$container_class[] =' realcrypto';
			// }
			
			if(isset($atts[strtolower('highLightRealtime')]) && $atts[strtolower('highLightRealtime')] == 'yes') {
				$container_class[] = 'rc-highLightRealtime';
			}
			if(isset($atts[strtolower('hightLightEvenRow')]) && $atts[strtolower('hightLightEvenRow')] == 'no') {
				$container_class[] = 'rc-hightLightEvenRowd-disable';
			}
			
			// Table options
			foreach ($atts as $key => $attr) {
				if(in_array($key, ['paging', 'ordering', 'info', 'searching'])) {
					$atts[$key] = ($attr == 'yes') ? 'true' : 'false';
				}
			}
			if(isset($atts['paging'])) {
				$table_atts .= 'data-paging="false" ';
			}
			if(isset($atts['ordering'])) {
				$table_atts .= 'data-ordering="'.$atts['ordering'].'" ';
			}
			if(isset($atts['info'])) {
				$table_atts .= 'data-info="'.$atts['info'].'" ';
			}
			if(isset($atts['searching'])) {
				$table_atts .= 'data-searching="'.$atts['searching'].'" ';
			}
			if(isset($atts['detail_url'])) {
				$table_atts .= 'data-detail-url="'.esc_attr($atts['detail_url']).'?'.BESTBUG_CRYPTO_QUERYVAR.'=" ';
			}
			if(isset($atts['skin'])) {
				$table_atts .= 'data-color="'.$atts['skin'].'" ';
			}
			
			$table_atts .= 'data-start="'.$atts['pagelength'].'" ';
			$table_atts .= 'data-limit="'.$atts['pagelength'].'" ';
			
			$dataCoins .= BESTBUG_CRYPTO_HELPER::row(0, $atts['pagelength']);
			
			$dataCoins .= '</tbody>';
			
			$dataHead = '';
			// if(in_array('rank', $table_fields)) {
			// 	$dataHead .= '<th data-priority="1">#</th>';
			// }
			// if(in_array('name', $table_fields)) {
			// 	$dataHead .= '<th data-priority="1" class="rc-name-wrap">'.esc_html__('Name','bestbug').'</th>';
			// }
			// if(in_array('price', $table_fields)) {
			// 	$dataHead .= '<th data-priority="2">'.esc_html__('Price','bestbug').'</th>';
			// }
			// if(in_array('supply', $table_fields)) {
			// 	$dataHead .= '<th>'.esc_html__('Supply','bestbug').'</th>';
			// }
			// if(in_array('volume', $table_fields)) {
			// 	$dataHead .= '<th>'.esc_html__('Volume','bestbug').'</th>';
			// }
			// if(in_array('market_cap', $table_fields)) {
			// 	$dataHead .= '<th>'.esc_html__('Market Cap','bestbug').'</th>';
			// }
			// if(in_array('change24h', $table_fields)) {
			// 	$dataHead .= '<th data-priority="3" width="120px">'.esc_html__('24H Change','bestbug').'</th>';
			// }
			
			return '<div class="'.implode(" ", $container_class).'">
		                <table class="realcrypto-table" width="100%" '.$table_atts.'>
							<thead>
								<th data-priority="1">#</th>
								<th data-priority="1" class="rc-name-wrap">'.esc_html__('Name','bestbug').'</th>
								<th data-priority="2">'.esc_html__('Price','bestbug').'</th>
								<th>'.esc_html__('Supply','bestbug').'</th>
								<th>'.esc_html__('Volume','bestbug').'</th>
								<th>'.esc_html__('Market Cap','bestbug').'</th>
								<th data-priority="3" width="120px">'.esc_html__('24H Change','bestbug').'</th>
							</thead>
		                    '.$dataCoins.'
		                </table>
						<div class="rc-load-more">
							<a class="rc-btn">'.esc_html__('Load more', 'bestbug').'</a>
						</div>
			        </div>';
		}
        
    }
	
	new BESTBUG_CRYPTO_TABLE_SHORTCODE();
}

