<?php
/*
Plugin Name: Ultimate Crypto Widgets
Description: Premium Cryptocurrency Widgets for WordPress.
Author: BestBug
Version: 1.3.2
Author URI: http://crypto.lamblue.com/
Text Domain: bestbug
Domain Path: /languages
*/

// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die;
}

defined( 'BESTBUG_CRYPTO_URL' ) or define('BESTBUG_CRYPTO_URL', plugins_url( '/', __FILE__ ));
defined( 'BESTBUG_CRYPTO_PATH' ) or define('BESTBUG_CRYPTO_PATH', basename( dirname( __FILE__ )));
defined( 'BESTBUG_CRYPTO_FULLPATH' ) or define('BESTBUG_CRYPTO_FULLPATH', plugins_url( '/', __FILE__ ));
defined( 'BESTBUG_CRYPTO_TEXTDOMAIN' ) or define('BESTBUG_CRYPTO_TEXTDOMAIN', plugins_url( '/', __FILE__ ));

defined( 'BESTBUG_CRYPTO_CATEGORY' ) or define('BESTBUG_CRYPTO_CATEGORY', 'Ultimate Crypto Widgets');
defined( 'BESTBUG_CRYPTO_PREFIX' ) or define('BESTBUG_CRYPTO_PREFIX', 'realcrypto_');

defined( 'BESTBUG_CRYPTO_QUERYVAR' ) or define('BESTBUG_CRYPTO_QUERYVAR', 'crypto');

// POSTTYPES
defined( 'BESTBUG_CRYPTO_POSTTYPE' ) or define('BESTBUG_CRYPTO_POSTTYPE', 'realcrypto');

// PAGE SLUG
defined( 'BESTBUG_CRYPTO_SLUG' ) or define('BESTBUG_CRYPTO_SLUG', 'real_crypto');
defined( 'BESTBUG_CRYPTO_SLUG_SETTINGS' ) or define('BESTBUG_CRYPTO_SLUG_SETTINGS', 'real_crypto_settings');
defined( 'BESTBUG_CRYPTO_ALL_REALCRYPTO_SLUG' ) or define('BESTBUG_CRYPTO_ALL_REALCRYPTO_SLUG', 'all_real_crypto');
defined( 'BESTBUG_CRYPTO_ADD_REALCRYPTO_SLUG' ) or define('BESTBUG_CRYPTO_ADD_REALCRYPTO_SLUG', 'add_real_crypto');

// SHORTCODES
defined( 'BESTBUG_CRYPTO_SHORTCODE' ) or define('BESTBUG_CRYPTO_SHORTCODE', 'realcrypto');
defined( 'BESTBUG_CRYPTOCOMPARE_SHORTCODE' ) or define('BESTBUG_CRYPTOCOMPARE_SHORTCODE', 'crypto_widgets');
defined( 'BESTBUG_CRYPTO_TABLE_SHORTCODE' ) or define('BESTBUG_CRYPTO_TABLE_SHORTCODE', 'realcrypto_table');
defined( 'BESTBUG_CRYPTO_TICKER_SHORTCODE' ) or define('BESTBUG_CRYPTO_TICKER_SHORTCODE', 'realcrypto_ticker');
defined( 'BESTBUG_CRYPTO_INLINE_SHORTCODE' ) or define('BESTBUG_CRYPTO_INLINE_SHORTCODE', 'realcrypto_inline');
defined( 'BESTBUG_CRYPTO_LEADERBOARD_SHORTCODE' ) or define('BESTBUG_CRYPTO_LEADERBOARD_SHORTCODE', 'realcrypto_leaderboard');
defined( 'BESTBUG_CRYPTO_SPARKCHARTS_SHORTCODE' ) or define('BESTBUG_CRYPTO_SPARKCHARTS_SHORTCODE', 'realcrypto_spark_charts');
defined( 'BESTBUG_CRYPTO_COMPARISON_SHORTCODE' ) or define('BESTBUG_CRYPTO_COMPARISON_SHORTCODE', 'realcrypto_comparison');
defined( 'BESTBUG_CRYPTO_CHART_SHORTCODE' ) or define('BESTBUG_CRYPTO_CHART_SHORTCODE', 'realcrypto_chart');
defined( 'BESTBUG_CRYPTO_BOX_SHORTCODE' ) or define('BESTBUG_CRYPTO_BOX_SHORTCODE', 'realcrypto_box');
defined( 'BESTBUG_CRYPTO_CONVERT_SHORTCODE' ) or define('BESTBUG_CRYPTO_CONVERT_SHORTCODE', 'realcrypto_convert');

// AJAX
defined( 'BESTBUG_CRYPTO_SAVE_SETTINS' ) or define('BESTBUG_CRYPTO_SAVE_SETTINS', 'bbcrypto_save_settings');
defined( 'BESTBUG_CRYPTO_AJAX_EXCHANGE_RATES' ) or define('BESTBUG_CRYPTO_AJAX_EXCHANGE_RATES', 'bbcrypto_exchange_rates');



if ( ! class_exists( 'BESTBUG_CRYPTO_CLASS' ) ) {
	/**
	 * BESTBUG_CRYPTO_CLASS Class
	 *
	 * @since	1.0
	 */
	class BESTBUG_CRYPTO_CLASS {
		/**
		 * Constructor
		 *
		 * @return	void
		 * @since	1.0
		 */
		function __construct() {
			// Load core
			if(!class_exists('BESTBUG_CORE_CLASS')) {
				include_once 'bestbugcore/index.php';
			}
			BESTBUG_CORE_CLASS::support('vc-params');
			BESTBUG_CORE_CLASS::support('options');
			BESTBUG_CORE_CLASS::support('posttypes');
			
			include_once 'includes/index.php';
			
			if(is_admin()) {
				include_once 'includes/admin/index.php';
			}
			include_once 'includes/widget.class.php';
			
			include_once 'includes/shortcodes/index.php';
			
            // add_action( 'init', array( $this, 'init' ) );
			$this->init();
			
			// Editor
			add_filter("mce_external_plugins", array( $this, "enqueue_plugin_scripts"));
			add_filter("mce_buttons", array( $this, "register_buttons_editor"));
			
			$loading = bb_option(BESTBUG_CRYPTO_PREFIX . 'loading');
			if($loading == 'yes') {
				add_action( 'wp_footer', array( $this, 'ajax_loading') );
			}
		}

		public function init() {
			
			// Load enqueueScripts
			if(is_admin()) {
				add_action( 'admin_enqueue_scripts', array( $this, 'adminEnqueueScripts' ) );
			}
			add_action( 'wp_enqueue_scripts', array( $this, 'enqueueScripts' ) );

        }

		public function adminEnqueueScripts() {
			BESTBUG_CORE_CLASS::adminEnqueueScripts();
			// wp_enqueue_style( 'css', BESTBUG_CRYPTO_URL . '/assets/admin/css/hint.min.css' );
			// wp_enqueue_script( 'js', BESTBUG_CRYPTO_URL . '/assets/js/wow.min.js', array( 'jquery' ), '1.1.3', true );
			$shortcodes = get_posts(array(
				'numberposts' => -1,
				'post_type' => BESTBUG_CRYPTO_POSTTYPE,
				'orderby' => 'title',
				'order'   => 'ASC',
			));
			$values = array();
			if(is_array($shortcodes)) {
				foreach ($shortcodes as $id => $shortcode) {
					$values[] = array(
						'text' => $shortcode->post_title,
						'value' => $shortcode->ID,
					);
				}
			}
			wp_enqueue_script( 'bb-crypto', BESTBUG_CRYPTO_URL . '/assets/admin/js/script.js', array( 'jquery' ), '1.0.4', true );
			wp_enqueue_script( 'sweetalert', BESTBUG_CORE_URL . '/assets/admin/js/sweetalert.min.js', array( 'jquery' ), null, true );
			wp_localize_script( 'jquery', 'REALCRYPTO_SHORTCODE', $values );
			wp_localize_script( 'jquery', 'REALCRYPTO_ICON', array(
				'REALCRYPTO_ICON' => BESTBUG_CRYPTO_URL . '/assets/admin/images/logo-20x20.png',
			 ) );
		}

		public function enqueueScripts() {
			BESTBUG_CORE_CLASS::enqueueScripts();
			
			wp_enqueue_style( 'bbcrypto', BESTBUG_CRYPTO_URL . '/assets/css/style.css' );
			wp_enqueue_style( 'dashicons' );
			
			wp_enqueue_script( 'dataTables', BESTBUG_CORE_URL .'/assets/admin/js/jquery.dataTables.min.js', array( 'jquery' ), '1.10.16', true );
			
			wp_enqueue_script( 'dataTables-responsive', BESTBUG_CORE_URL .'/assets/admin/js/dataTables.responsive.js', array( 'jquery' ), '2.1.1', true );
			
			wp_enqueue_script( 'numeral',  BESTBUG_CRYPTO_URL .  '/assets/js/numeral.min.js', array( 'jquery' ), '2.1.1', true );
			
			wp_enqueue_script( 'select2', BESTBUG_CORE_URL . '/assets/admin/js/select2.min.js', array( 'jquery' ), '4.0.3', true );
			wp_enqueue_script( 'marquee', BESTBUG_CRYPTO_URL . '/assets/js/jquery.marquee.min.js', array( 'jquery' ), '1.4.0', true );
			wp_enqueue_script( 'sparkline', BESTBUG_CRYPTO_URL . '/assets/js/jquery.sparkline.min.js', array( 'jquery' ), '2.1.2', true );
			wp_enqueue_script( 'chartjs', BESTBUG_CRYPTO_URL . '/assets/js/Chart.bundle.min.js', array( 'jquery' ), '2.7.1', true );
			wp_enqueue_script( 'socket-io', BESTBUG_CRYPTO_URL . '/assets/js/socket.io.js', array( 'jquery' ), '2.0.3', true );
			wp_enqueue_script( 'bb-crypto', BESTBUG_CRYPTO_URL . '/assets/js/script.js', array( 'jquery' ), '1.3', true );
			
			$currency = bb_option(BESTBUG_CRYPTO_PREFIX . 'currency');
			$symbol = $currency;
			if(isset(BESTBUG_CRYPTO_HELPER::$currencies_symbol->{$symbol})) {
				$symbol = BESTBUG_CRYPTO_HELPER::$currencies_symbol->{$symbol}->symbol_native;
			}
			$rates = BESTBUG_CRYPTO_HELPER::cacheRates();
			// BESTBUG_CRYPTO_HELPER::cacheCoinImages(true);
			
			if(!isset($rates['USD'])) {
				$rates['USD'] = 1;
			}
			wp_localize_script( 'bb-crypto', 'UCW_SETTINGS',
			    array( 
			        'ajaxurl'   => admin_url( 'admin-ajax.php' ),
					'CURRENCY' => ($currency == '' )?'USD':$currency,
			        // 'ajaxnonce' => wp_create_nonce( 'itr_ajax_nonce' ),
					'IMAGES' => BESTBUG_CRYPTO_HELPER::coinImages(),
					'IMAGES_URL' => BESTBUG_CRYPTO_HELPER::$image_url,
					'COINS' => BESTBUG_CRYPTO_HELPER::coinList(),
					'RATES' => $rates,
					'CURRENCY_SYMBOL' => $symbol,
			    )
			);
		}

		public function loadTextDomain() {
			load_plugin_textdomain( BESTBUG_CRYPTO_TEXTDOMAIN, false, BESTBUG_CRYPTO_PATH . '/languages/' );
		}
		
		// Button TinyMCE
		function enqueue_plugin_scripts($plugin_array)
		{
		    //enqueue TinyMCE plugin script with its ID.
		    $plugin_array["realcrypto"] =  BESTBUG_CRYPTO_URL . 'assets/admin/js/realcrypto-editor.js';
		    return $plugin_array;
		}
		function register_buttons_editor($buttons)
		{
		    //register buttons with their id.
		    array_push($buttons, BESTBUG_CRYPTO_SHORTCODE);
		    return $buttons;
		}
		
		public function ajax_loading(){
			$bg_loading = bb_option(BESTBUG_CRYPTO_PREFIX . 'bg_loading');
			$style = '';
			if($bg_loading != '') {
				$style = 'style="background: ' . $bg_loading . '";';
			}
			echo '<div class="rc-ajax-loading" '.$style.'>
					<div class="bb-ajax-box">
						<div class="bb-spinner">
						  <div class="cube1"></div>
						  <div class="cube2"></div>
						</div>
					</div>
				</div>';
		}

	}
	new BESTBUG_CRYPTO_CLASS();
}
